#include "map.h"
#include "aswm/log/log.h"
#include "aswm/mapper/mapper.h"
#include "aswm/log/log.h"
#include "X11/Xutil.h"

void OnMapRequest(Aswm* aswm, const XMapRequestEvent* e) {
	aswm_notice("XMapRequestEvent %lu", e->window);

	XSizeHints* size = XAllocSizeHints();
	long supplied;
	bool stacked = false;
	if(XGetWMNormalHints(aswm->display, e->window, size, &supplied)) {
		if((supplied & (PMinSize | PMaxSize)) && !aswm_is_resizeable(size)) {
			aswm_notice("\tWMNormalHints:");
			aswm_notice("\t\tMin w:%i", size->min_width);
			aswm_notice("\t\tMin h:%i", size->min_height);
			aswm_notice("\t\tMax w:%i", size->max_width);
			aswm_notice("\t\tMax h:%i", size->max_height);
			aswm_stack_window(e->display, aswm->current_desktop.stack_root, e->window, size->max_width, size->max_height);
			stacked = true;
		}
	}
	XFree(size);

	if(!stacked)
		aswm_tile_window(e->display, aswm->current_desktop.tile_root, e->window);

	aswm_info("Map tree:\n");
	aswm_log_tree(aswm_info, aswm, DefaultRootWindow(aswm->display), 1);
}
