#include "aswm.h"
#include "argparse.h"

#ifndef ASWM_LOG_CONF
#define ASWM_LOG_CONF NULL
#endif

static const char *const usages[] = {
    "aswm [options]",
    NULL,
};

int main(int argc, const char** argv) {
    const char *zlog_conf = NULL;
    struct argparse_option options[] = {
        OPT_HELP(),
        OPT_GROUP("Config options"),
        OPT_STRING('l', "log", &zlog_conf, "path to zlog config file", NULL, 0, 0),
        OPT_END(),
    };

    struct argparse argparse;
    argparse_init(&argparse, options, usages, 0);
    argparse_describe(&argparse, "\nLaunches ASWM", "\nASWM is an Arcade Station Window Manager");
    argc = argparse_parse(&argparse, argc, argv);

	if (zlog_conf == NULL) {
		zlog_conf = ASWM_LOG_CONF;
	}

	aswm_open(zlog_conf);
	aswm_event_loop();
	aswm_close();
}
