#include "aswm/aswm.h"
#include <sys/wait.h>

#include "../test_set_up.h"
#include "test_aswm_create_windows.h"

void run_aswm(void) {
	int stat_loc;
	// A return value of 0 indicates that the status of aswm_pid is not yet
	// available, i.e. aswm is running
	TEST_ASSERT_EQUAL_INT(0, waitpid(aswm_pid, &stat_loc, WNOHANG));
}

// not needed when using generate_test_runner.rb
int main(void) {
    UNITY_BEGIN();
	set_up_test_logger();
	if(check_xephyr_available()) {
		RUN_TEST(run_aswm);
		RUN_TEST(create_single_resizeable_top_level_window);
		RUN_TEST(create_multiple_resizeable_top_level_window);
	}
	tear_down_test_logger();
    return UNITY_END();
}
